image: ubuntu:20.04

build-star2lte:
  stage: build
  script:
    - apt update
    - apt install android-tools-mkbootimg bc bison build-essential ca-certificates cpio curl flex git kmod libssl-dev libtinfo5 python2 sudo unzip wget xz-utils -y --no-install-recommends
    - ln -sf python2.7 /usr/bin/python
    - wget https://raw.githubusercontent.com/LineageOS/android_system_core/lineage-17.1/mkbootimg/mkbootimg.py -O /usr/bin/mkbootimg
    - ln -s deviceinfo-star2lte deviceinfo
    - ./build.sh
  artifacts:
    paths:
      - out/*

build-starlte:
  stage: build
  script:
    - apt update
    - apt install android-tools-mkbootimg bc bison build-essential ca-certificates cpio curl flex git kmod libssl-dev libtinfo5 python2 sudo unzip wget xz-utils -y --no-install-recommends
    - ln -sf python2.7 /usr/bin/python
    - wget https://raw.githubusercontent.com/LineageOS/android_system_core/lineage-17.1/mkbootimg/mkbootimg.py -O /usr/bin/mkbootimg
    - ln -s deviceinfo-starlte deviceinfo
    - ./build.sh
  artifacts:
    paths:
      - out/*

build-crownlte:
  stage: build
  script:
    - apt update
    - apt install android-tools-mkbootimg bc bison build-essential ca-certificates cpio curl flex git kmod libssl-dev libtinfo5 python2 sudo unzip wget xz-utils -y --no-install-recommends
    - ln -sf python2.7 /usr/bin/python
    - wget https://raw.githubusercontent.com/LineageOS/android_system_core/lineage-17.1/mkbootimg/mkbootimg.py -O /usr/bin/mkbootimg
    - ln -s deviceinfo-crownlte deviceinfo
    - ./build.sh
  artifacts:
    paths:
      - out/*

flashable-star2lte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-star2lte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/fetch-and-prepare-latest-ota.sh "16.04/arm64/android9/devel" "$DEVICE" ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
  artifacts:
    paths:
      - out/boot.img
      - out/system.img
  when: manual

flashable-starlte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-starlte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/fetch-and-prepare-latest-ota.sh "16.04/arm64/android9/devel" "$DEVICE" ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
  artifacts:
    paths:
      - out/boot.img
      - out/system.img
  when: manual

flashable-crownlte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-crownlte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/fetch-and-prepare-latest-ota.sh "16.04/arm64/android9/devel" "$DEVICE" ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
  artifacts:
    paths:
      - out/boot.img
      - out/system.img
  when: manual

devel-flashable-star2lte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-star2lte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/prepare-fake-ota.sh out/device_$DEVICE.tar.xz ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
    - mv out/rootfs.img out/ubuntu.img
  artifacts:
    paths:
      - out/boot.img
      - out/ubuntu.img

devel-flashable-starlte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-starlte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/prepare-fake-ota.sh out/device_$DEVICE.tar.xz ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
    - mv out/rootfs.img out/ubuntu.img
  artifacts:
    paths:
      - out/boot.img
      - out/ubuntu.img

devel-flashable-crownlte:
  stage: deploy
  script:
    - apt update
    - apt install -y img2simg jq sudo wget xz-utils
    - ln -s deviceinfo-crownlte deviceinfo
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/prepare-fake-ota.sh out/device_$DEVICE.tar.xz ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
    - mv out/rootfs.img out/ubuntu.img
  artifacts:
    paths:
      - out/boot.img
      - out/ubuntu.img